#ifndef DEVICE_CU
#define DEVICE_CU

#include <iostream>

__constant__ int k [256]; 

#include "device.h"
#include "device_kernel.cu"

using namespace std;



testclass::testclass()
{
  values = 4;
  memsize = values * sizeof(float);

  h_data = (float *) malloc(memsize);
  float f=0.0f; 
  for(int i=0; i< values; i++, f+=1.0f)
    h_data[i] = f;

  cudaMalloc((void**) &d_data, memsize);
  cudaMemcpy(d_data, h_data, memsize, cudaMemcpyHostToDevice);
}

testclass::~testclass()
{
  free(h_data);
  cudaFree(d_data);
  cudaThreadExit();
}

void testclass::test()
{
  std::cout << endl << "this is compiled by nvcc using c++ compiler";
                                               /* setup execution parameters */
  dim3 grid(1, 1, 1);
  dim3 threads(4, 1, 1);
  
  int i = 20; 
  cudaMemcpyToSymbol(k, &i, sizeof(int));

  kernel<<<grid, threads>>>(d_data);

  cudaMemcpy(h_data, d_data, memsize, cudaMemcpyDeviceToHost);

  std::cout << endl << h_data[0] << " " << h_data[1] << " " 
    << h_data[2] << " " << h_data[3] << endl;
}


#endif
